/*
* @version $Id: calculator.js 276 2009-12-28 14:11:28Z Mansur $
* @copyright Copyright (C) 2008 Abricos All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

/**
 * @module Calculator
 * @namespace Brick.mod.calculator
 */
var Component = new Brick.Component();
Component.requires = {
    mod:[
	    {name: 'sys', files: ['container.js']}
    ]
};
Component.entryPoint = function(){
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var NS = this.namespace,
		TMG = this.template;

	var API = NS.API;	

(function(){
	
	/**
	 * Панель калькулятора.
	 * 
	 * @class CalculatorPanel
	 */
	var CalculatorPanel = function(){
		
		CalculatorPanel.superclass.constructor.call(this, {
			width: "310px", height: "245px",
			fixedcenter: true
		});
	};
	
	YAHOO.extend(CalculatorPanel, Brick.widget.Panel, {
		initTemplate: function(){
			var TM = TMG.build('panel'), T = TM.data, TId = TM.idManager;
			this._TM = TM; this._T = this._TM.data; this._TId = TId;			
			return T['panel'];
		},
		onLoad: function(){				
			this.NUM = 0;
			this.OPER = 1;
			this.i = 0;
			this.y = 0;
			this.valueElement = 0;
			this.typeElement = 0;
			this.reset = false;
			this.point = false;
			this.equals = false;
			this.sign = false;
			this.mathText = '';
			this.worker = '';
			this.value = '';
			this.log = '';
			this.type = '';
			this.oper = '';
			this.num = '';			
			this.oldValue = '';
			this.oldType = '';
			this.oldLog = '';
			this.oldOper = '';
			this.oldNum = '';			
			/* пpиоpитеты: + - * / . = */
			this.pr =    [ 2,2,3,3,0,1 ];
			this.addition=0;
			this.subtraction=1;
			this.multiply=2;
			this.divide=3;
			this.po=4;
			this.eq=5;
			this.Number = ['0','1','2','3','4','5','6','7','8','9'];
			this.Operator = ['+','-','*','/','.','=','%','(',')','adv','del','log','c','sqrt','inv','sign'];
			this.Operator['+'] = this.addition;
			this.Operator['-'] = this.subtraction;
			this.Operator['*'] = this.multiply;
			this.Operator['/'] = this.divide;
			this.Operator['.'] = this.po;
			this.Operator['='] = this.eq;
			
			this.Number.check =
				this.Operator.check = function(value){
				for (var i=0;i<this.length;i++){
					if (value == this[i]){ return true; }
				}
				return false;
			};
			this.Number.get = 
				this.Operator.get = function(value){
				for (var i=0;i<this.length;i++){
					if (value == this[i]){ return value; }
				}
				return false;
			};
		},		
		onClick: function(el){														
			var TId = this._TId;					
			switch(el.id)
			{
				case TId['panel']['adv']:{
					this.displayUpdate('adv');
					return true;
				}
				case TId['panel']['del']:{
					this.displayUpdate('del'); 
					return true;
				}
				case TId['panel']['log']:{
					this.displayUpdate('log'); 
					return true;
				}
				case TId['panel']['reset']:{
					this.displayUpdate('c'); 
					return true;
				}
				case TId['panel']['divide']:{
					this.displayUpdate('/');
					return true;
				}
				case TId['panel']['sqrt']:{
					this.displayUpdate('sqrt'); 
					return true;
				}
				case TId['panel']['multiply']:{
					this.displayUpdate('*'); 
					return true;
				}
				case TId['panel']['remainder']:{
					this.displayUpdate('%'); 
					return true;
				}
				case TId['panel']['subtraction']:{
					this.displayUpdate('-'); 
					return true;
				}
				case TId['panel']['invert']:{
					this.displayUpdate('inv'); 
					return true;
				}
				case TId['panel']['sign']:{
					this.displayUpdate('sign'); 
					return true;
				}
				case TId['panel']['point']:{
					this.displayUpdate('.'); 
					return true;
				}
				case TId['panel']['addition']:{
					this.displayUpdate('+'); 
					return true;
				}
				case TId['panel']['equals']:{
					this.displayUpdate('='); 
					return true;
				}
				case TId['panel']['zero']:{
					this.displayUpdate('0');
					return true;
				}
				case TId['panel']['one']:{
					this.displayUpdate('1');
					return true;
				}
				case TId['panel']['two']:{
					this.displayUpdate('2');
					return true;
				}
				case TId['panel']['three']:{
					this.displayUpdate('3');
					return true;
				}
				case TId['panel']['four']:{
					this.displayUpdate('4');
					return true;
				}
				case TId['panel']['five']:{
					this.displayUpdate('5');
					return true;
				}
				case TId['panel']['six']:{
					this.displayUpdate('6');
					return true;
				}
				case TId['panel']['seven']:{
					this.displayUpdate('7');
					return true;
				}
				case TId['panel']['eight']:{
					this.displayUpdate('8');
					return true;
				}
				case TId['panel']['nine']:{
					this.displayUpdate('9');
					return true;
				}
				return false;
			}			
		},
		calculate: function(){
			var NUM = this.NUM;
			var OPER = this.OPER;
			var result = 0;
			var operator;
			var priority;
			var operatorStack = [];
			var priorityStack = [];
			var valueStack = [];			
			var i = this.i;
			this.y=0;			
			
			if(!this.getElement()){		
				i=1;						
				do{
					if(this.typeElement == NUM ){
						valueStack[i] = this.valueElement;				
						if(this.getElement()) return 1;
					}
					operator = this.valueElement;
					if(this.Operator[operator] >= 0 && this.Operator[operator] <= 5){
						priority = (operator == '-' && valueStack.length == 0)? 4 : this.pr[this.Operator[operator]-this.addition];
						this.getElement();
					}
					else{ alert('Error!'); return 1; }					
					while(i > 1 && (priority < priorityStack[i - 1] || priority == priorityStack[i - 1] && priority != 4 && operator!= '=')){
						valueStack[i-1] = this.action(operatorStack[i-1], valueStack[i-1], valueStack[i]); 
						i--;
					}
					if(operator != '='){
						operatorStack[i] = operator;
						priorityStack[i] = priority;
						i++;
					}					
				}while(i>1);
				result = valueStack[i];
			    if(this.sign) result = 0-result;
				this.i = i;				
				return result;
			}else return 1;
		},		
		action: function(operator, value1, value2){ 
			switch(operator){
			case '+': return value1 + value2; 
			case '-': return value1 - value2; 
			case '*': return value1 * value2; 
			case '/': return value1 / value2; 
			}			
		},
		getElement: function(){			
			var mathText = this.mathText;  		
			var y = this.y;
			var sim;			
			
			if(sim = mathText.charAt(y)){				
				var NUM = this.NUM;
				var OPER = this.OPER;
				var typeElement = this.typeElement;
				var valueElement = this.valueElement;
				var sFlag = false;
				
				if(y == 0){
					if(mathText.charAt(y)=='-'){
						sFlag = true;
						sim = mathText.charAt(++y);
					}
				}
				if(sim >= '0' && sim<='9' || sim == '.'){
					typeElement = NUM;
					valueElement = 0;					
					if(sim != '.'){
						do{
							valueElement = valueElement * 10 + (sim - '0');
							sim = mathText.charAt(++y);
						}while(sim >= '0' && sim<='9');
					}
					if(sim == '.'){
						sim = mathText.charAt(++y);
						while(sim >= '0' && sim<='9'){	
							valueElement = valueElement + (sim - '0') / 10;
							sim = mathText.charAt(++y);
						}
					}
					if(sFlag) valueElement = 0 - valueElement;
				}else{
					typeElement = OPER;
					valueElement = sim; 
					y++;	
				}			
				this.typeElement = typeElement;
				this.valueElement = valueElement;
				this.y = y;
				return 0;
			}else return 1;			
		},
		getTypeValue: function(value){
			var NUM = this.NUM;
			var OPER = this.OPER;
			
			if (this.Number.check(value)){
				return NUM; 
			}else if (this.Operator.check(value)){ 
				return OPER;
			}
			return -1;
		},
		displayUpdate: function(designation){
			var display = this._TM.getEl('panel.display').value;
			var NUM = this.NUM;
			var OPER = this.OPER;
			var value = designation;
			var type = this.getTypeValue(value);
			var oper = this.Operator.get(value);
			var num = this.Number.get(value);
			var oldType = this.oldType;
			var oldOper = this.oldOper;
			var oldNum = this.oldNum;
			var point = this.point;
			var reset = this.reset;
			var log = this.log;
			var equals = this.equals;
			var worker = this.worker;
			
			if(reset) { 
				display = '';
				reset = false;
				equals = false;
				point = false;
			}
			
			if (type < 0){
				alert('unknow type value');
			}
			else if(display == ''){
				if (type == OPER){ 
					if(oper == '-'){
						oldOper = oper;
						oldType = type;
						display = value;
					}else if(oper == '.'){  
						point = true;
						oldOper = oper;
						oldType = type;
						display = '0'+value;
					}
				}else{
					oldNum = num;
					oldType = type;
					display = value;
				}
			}else{
				if (type == OPER){
					if(oper == 'adv'){
						
					}else if(oper == 'del'){
						if(display.charAt(display.length-1)=='.') point = false;
						if(display.length > 1)display = display.substring(0, display.length-1);
						else{ display = '0'; reset = true;}						
					}else if(oper == 'log'){
						 
					}else if(oper == 'c'){
						display = '0';
						reset = true;
					}else if(oper == 'sqrt'){
						
					}else if(oper == '%'){
						 
					}else if(oper == 'inv'){
						 
					}else if(oper == 'sign'){
						if(oldType == OPER){
							display = display.substring(1, display.length-oldOper.length)+'=';
						}
						else{
							display += '=';
						}					
						this.sign = true;
						log += '-/+  '+display+'> ';
					}else if(oper == '='){
						if(equals){
							display = display+worker+'=';
						}
						else if(oldOper == '-' || oldOper == '+' || oldOper == '/' || oldOper == '*'){
							if(!equals){								
								worker = oldOper + display.substring(0, display.length-1);								
								display += display.substring(0, display.length-1)+'=';
								equals = true;								
							}
						}
						else{
							display += '=';
						}
						log += display;												
					}else{
						if(oldType == NUM){
							if(oper == '.'){
								if(!point){
									oldType = type;
									display += value;
									point = true;
								}
							}
							else {
								oldType = type;
								display += value;
								point = false;
							}
						}else if(oldType == OPER){
							if(oldOper == '-' && display.length == 1){
								display = '';
							}
							if(display.length > 0){
								display = display.substring(0, display.length-oldOper.length)+value;
							}
						}
					}					
					if	( oper != '-' && oper != '+' && oper != '/' && oper != '*' && oper != '.'
						&& oper != 'del' && oper != 'adv' && oper != 'log' && oper != 'c'){
							this.mathText = display;
							display = this.calculate()+'';
							log += display+'\n';
					}else{
						equals = false;
					}					
				}else{
					if(num == '0'){
						if(display.substring(0,1) != '0' || point){
							oldType = type;
							display += value;
						}						
					}else{									
						oldType = type;
						display += value;
					}
					equals = false;
				}				
			}
			oldOper = oper;
			oldNum = num;
			
			this.oldType = oldType;
			this.oldOper = oldOper;
			this.oldNum = oldNum;
			this.point = point;
			this.reset = reset;
			this.log = log;
			this.equals = equals;
			this.worker = worker;
			this._TM.getEl('panel.display').value = display;
			this._TM.getEl('panel.log').value = log;
		}		
	});
	NS.CalculatorPanel = CalculatorPanel;
})();

};