<?php
/**
 * Схема таблиц модуля
 * 
 * @version $Id: shema.php 1413 2012-02-02 09:09:11Z roosit $
 * @package Abricos
 * @subpackage Company
 * @copyright Copyright (C) 2008 Abricos All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * @author Alexander Kuzmin (roosit@abricos.org)
 */

$charset = "CHARACTER SET 'utf8' COLLATE 'utf8_general_ci'";
$updateManager = Ab_UpdateManager::$current; 
$db = Abricos::$db;
$pfx = $db->prefix;

$modCalendar = Abricos::GetModule('calendar'); 
$modCompany = Abricos::GetModule('company'); 

if ($updateManager->isInstall()){

	// Таблица сотрудников не используется с версии 0.1.3.1
	/*
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."cmpn_employee (
		  `employeeid` int(10) unsigned NOT NULL auto_increment,
		  `userid` int(10) unsigned NOT NULL,
		  `lastname` varchar(50) NOT NULL default '' COMMENT 'Фамилия',
		  `firstname` varchar(50) NOT NULL default '' COMMENT 'Имя',
		  `patronymic` varchar(50) NOT NULL default '' COMMENT 'Отчество',
		  `postid` int(3) unsigned NOT NULL default '0' COMMENT 'Идентификатор должности',
		  `deptid` int(3) unsigned NOT NULL default '0' COMMENT 'Идентификатор отдела',
		  `phones` varchar(200) NOT NULL default '' COMMENT 'Номера телефонов',
		  `room` varchar(20) NOT NULL default '' COMMENT 'Номер кабинета',
		  `dateline` int(10) unsigned NOT NULL default '0' COMMENT 'Дата добавления сотрудника',
		  `deldate` int(10) unsigned NOT NULL default '0' COMMENT 'Дата удаления',
		  PRIMARY KEY  (`employeeid`),
		  KEY `userid` (`userid`)
		)".$charset
	);
	/**/
	
	// Справочник должностей
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."cmpn_post (
		  `postid` int(3) unsigned NOT NULL auto_increment,
		  `name` varchar(250) NOT NULL default '' COMMENT 'Наименование должности',
		  `level` int(3) unsigned NOT NULL Default 0 COMMENT 'Уровень авторитета должности, 0-наивысший',
		  PRIMARY KEY  (`postid`)
		)".$charset
	);

	// Справочник отделов
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."cmpn_dept (
		  `deptid` int(3) unsigned NOT NULL auto_increment,
		  `name` varchar(250) NOT NULL default '' COMMENT 'Наименование отдела',
		  `ord` int(3) unsigned NOT NULL Default 0 COMMENT 'Сортировка',
		  PRIMARY KEY  (`deptid`)
		)".$charset
	);
}

if ($updateManager->isUpdate('0.1.1')){
	// Настройки доступа к календарю
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."cmpn_calperm (
		  `calpermid` int(10) unsigned NOT NULL auto_increment,
		  `userid` int(10) unsigned NOT NULL default '0',
		  `calin` TEXT NOT NULL COMMENT 'Смотреть календарь: ID сотрудников через запятую с префиксом #',
		  `calout` TEXT NOT NULL COMMENT 'Разрешить смотреть календарь: ID сотрудников через запятую с префиксом #',
		  `options` TEXT NOT NULL COMMENT 'Дополнительные настройки календаря',
		  PRIMARY KEY  (`calpermid`),
		  KEY `userid` (`userid`)
		)".$charset
	);
}

if ($updateManager->isUpdate('0.1.2')){
	$db->query_write("DROP TABLE IF EXISTS ".$pfx."cmpn_caltask");
	/*
	if (!empty($modCalendar)){
		$db->query_write("
			UPDATE `".$pfx."cdr_task` 
			SET 
				permlevel=1,
				owner='cmpn'
		");
	}
	/**/
}

$uprofileManager = Abricos::GetModule('uprofile')->GetManager(); 

if ($updateManager->isUpdate('0.1.3.1')){
	$uprofileManager->FieldAppend('lastname', 'Фамилия', UserFieldType::STRING, 100);
	$uprofileManager->FieldAppend('firstname', 'Имя', UserFieldType::STRING, 100);
	$uprofileManager->FieldAppend('patronymic', 'Отчество', UserFieldType::STRING, 100);
	$uprofileManager->FieldAppend('dept', 'Отдел', UserFieldType::TABLE, 3, array("options" => "cmpn_dept|name"));
	$uprofileManager->FieldAppend('post', 'Должность', UserFieldType::TABLE, 3, array("options" => "cmpn_post|name"));
	$uprofileManager->FieldAppend('phones', 'Телефоны', UserFieldType::STRING, 250);
	$uprofileManager->FieldAppend('room', 'Кабинет', UserFieldType::STRING, 20);
	$uprofileManager->FieldAppend('isemployee', 'Сотрудник', UserFieldType::BOOLEAN, 1, array("access"=>UserFieldAccess::SYSTEM));
	$uprofileManager->FieldCacheClear();
}

if ($updateManager->isUpdate('0.1.3.1') && !$updateManager->isInstall()){
	
	$db->query_write("ALTER TABLE `".$pfx."cmpn_calperm` ADD `userid` int(10) unsigned NOT NULL default '0' AFTER calpermid");
	
	$rows = $db->query_read("SELECT * FROM ".$pfx."cmpn_employee");
	while (($row = $this->db->fetch_array($rows))){
		$db->query_write("
			UPDATE ".$pfx."user
			SET
				lastname='".$row['lastname']."',
				firstname='".$row['firstname']."',
				patronymic='".$row['patronymic']."',
				deptid=".$row['deptid'].",
				postid=".$row['postid'].",
				phones='".$row['phones']."',
				room='".$row['room']."',
				isemployee=1
			WHERE userid=".$row['userid']."
		");
		$db->query_write("
			UPDATE ".$pfx."cmpn_calperm
			SET
				userid='".$row['userid']."'
			WHERE employeeid=".$row['employeeid']."
		");
	}
	$db->query_write("ALTER TABLE `".$pfx."cmpn_calperm` DROP `employeeid`");
	$db->query_write("DROP TABLE `".$pfx."cmpn_employee`");
}

if ($updateManager->isUpdate('0.1.3.2')){
	$uprofileManager = Abricos::GetModule('uprofile')->GetManager(); 
	$uprofileManager->FieldAccessUpdate('isemployee', UserFieldAccess::SYSTEM);
}
if ($updateManager->isUpdate('0.1.4')){
	$modCompany->permission->Install();
}
if ($updateManager->isUpdate('0.1.4') && !$updateManager->isInstall()){
	$rows = $db->query_read("
		SELECT 
			userid as id, 
			isemployee as emp
		FROM ".$db->prefix."user
		WHERE isemployee > 0
	");
	while (($row = $db->fetch_array($rows))){
		UserQueryExt::UserGroupAppendByKey($db, $row['id'], CompanyGroup::EMPLOYEE);
	}
	$uprofileManager->FieldRemove('isemployee');
	$uprofileManager->FieldCacheClear();
}

?>