/*
@version $Id: project.js 694 2010-08-26 07:31:16Z roosit $
@package Abricos
@copyright Copyright (C) 2008 Abricos All rights reserved.
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	yahoo: ['dom'],
	mod:[
		{name: 'sys', files: ['data.js']},
        {name: 'eprice', files: ['lib.js']}
	]
};
Component.entryPoint = function(){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang,
		NS = this.namespace, 
		TMG = this.template,
		API = NS.API;

	if (!NS.data){
		NS.data = new Brick.util.data.byid.DataSet('eprice');
	}
	
	var buildTemplate = function(w, templates){
		var TM = TMG.build(templates), T = TM.data, TId = TM.idManager;
		w._TM = TM; w._T = T; w._TId = TId;
	};
	
	var PriceColumnTable = function(){
		this.init();
	};
	PriceColumnTable.prototype = {
		init: function(){
			this.tables = new Brick.mod.sys.TablesManager(NS.data, ['eloption'], {'owner': this});		
		},
		getRows: function(){
			return this.tables.get('eloption').getRows().filter({'fldtp': '2'});
		},
		getTitle: function(column){
			var row = this.getRows().find({'nm': column});
			
			if (L.isNull(row)){
				return '';
			}
			return row.cell['tl'];
		},
		destroy: function(){
			this.tables.destroy();
		}
	};
	NS.PriceColumnTable = PriceColumnTable;
	

	var PriceColumnSelectWidget = function(container, config){
		config = L.merge({
			'readonly': false
		}, config || {});
		this.init(container, config);
	};
	PriceColumnSelectWidget.prototype = {
		init: function(container, config){
			this.config = config;
			
			this.container = Dom.get(container);
			this.selectedValue = null;
			
			this.onChange = new YAHOO.util.CustomEvent("onChange");
			
			buildTemplate(this, 'seltable,selrow,selrowwait');
			
			this.tables = new Brick.mod.sys.TablesManager(NS.data, ['eloption'], {'owner': this});
		},
		destroy: function(){
			this.tables.destroy();
		},
		onDataLoadWait: function(tables){
			var TM = this._TM, T = this._T;
			this.container.innerHTML = TM.replace('seltable', {'rows': T['selrowwait']});
		},
		onDataLoadComplete: function(tables){
			this.tables = tables;
			this.render();

			var __self = this;
			var el = this._TM.getEl('seltable.id');
			E.on(el, 'change', function(){
				__self.onChange.fire(el.value);
			});
		},
		render: function(){
			var lst = "", TM = this._TM, T = this._T;
			
			this.getRows().foreach(function(row){
				var di = row.cell;
				lst += TM.replace('selrow', {
					'id': di['nm'],
					'tl': di['tl']
				});
			});
			this.container.innerHTML = TM.replace('seltable', {'rows': lst});
			/*
			if (L.isNull(this.selectedValue)){
				var row = this.getRows().getByIndex(0);
				if (!L.isNull(row)){
					this.setValue(row.cell['nm']);
				}
			}else{
				this.setValue(this.selectedValue);
			}
			/**/
			
			this.setValue(this.selectedValue);
		},
		getRows: function(){
			return this.tables.get('eloption').getRows().filter({'fldtp': '2'});
		},
		getValue: function(){
			return this._TM.getEl('seltable.id').value;
		},
		setValue: function(value){
			var row = this.getRows().find({'nm': value});
			
			if (L.isNull(row)){
				var row = this.getRows().getByIndex(0);
				if (L.isNull(row)){
					return; 
				}
				value = row.cell['nm'];
			}
			
			this.selectedValue = value;
			this._TM.getEl('seltable.id').value = value;
		},
		setReadonly: function(readonly){
			this.config.readonly = readonly;
			this.render();
		}
	};
	NS.PriceColumnSelectWidget = PriceColumnSelectWidget;

};