/*
@version $Id: project.js 705 2010-09-08 12:47:39Z Mansur $
@package Abricos
@copyright Copyright (C) 2008 Abricos All rights reserved.
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	yahoo: ['dom'],
	mod:[
		{name: 'sys', files: ['data.js', 'container.js']},
        {name: 'eprice', files: ['product.js']}
	]
};
Component.entryPoint = function(){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var NS = this.namespace, 
		TMG = this.template,
		API = NS.API;

	var N = NS.lib.Number, NF = NS.lib.NumberFormat;

	if (!NS.data){
		NS.data = new Brick.util.data.byid.DataSet('eprice');
	}
	var DATA = NS.data;
	
	var buildTemplate = function(w, templates){
		var TM = TMG.build(templates), T = TM.data, TId = TM.idManager;
		w._TM = TM; w._T = T; w._TId = TId;
	};
	
	var isRenderList = false;
	
	var PriceWidget = function(container, companyid){
		companyid = companyid || 0;
		this.init(container, companyid);
	};
	PriceWidget.prototype = {
		init: function(container, companyid){
			buildTemplate(this, 'widget,ptable,prowwait,prow,hcol,rcol');
			isRenderList = false;
			var TM = this._TM;
			container.innerHTML = TM.replace('widget');
			
			this.tables = new Brick.mod.sys.TablesManager(NS.data, ['productlist', 'eloption'], {'owner': this});
			
			this._startThread();
		},
		destroy: function(){
			this._stopThread();
			this.save();
			this.tables.destroy();
		},
		onResize: function(rel){
			var el = this._TM.getEl('widget.table');
			el.style.height = (rel.height - 30)+'px';
		},
		onDataLoadWait: function(tables){
			if (isRenderList){ return; }
			var TM = this._TM;
			TM.getEl('widget.table').innerHTML = TM.replace('ptable', {
				'cols': '',
				'rows': this._T['prowwait']}
			);
		},
		onDataLoadComplete: function(tables){
			this.tables = tables;
			if (isRenderList){ return; }
			isRenderList = true;

			var TM = this._TM, TId = this._TId, lst = "", index = 1;
			var pRows = this.getPriceRows();
			
			tables.get('productlist').getRows().foreach(function(row){
				var di = row.cell;
				var cols = "";
				pRows.foreach(function(crow){
					var nm = crow.cell['nm'];
					cols += TM.replace('rcol', {
						'nm': nm,
						'pc': N.format(di[nm], NF),
						'id': di['id']
					});
				});
				lst += TM.replace('prow', {
					'n': index++,
					'id': di['id'], 'tl': di['tl'],
					'cols': cols,
					'cnt':  di['cnt'],
					'ord':  di['ord']
				});
			});
			
			TM.getEl('widget.table').innerHTML = TM.replace('ptable', {
				'cols': function(){
					var cols = "";
					pRows.foreach(function(crow){
						cols += TM.replace('hcol', {'tl': crow.cell['tl'] });
					});
					return cols;
				}(),
				'rows': lst
			});
		},
		onClick: function(el){
			return false;
		},
		getPriceRows: function(){
			return this.tables.get('eloption').getRows().filter({'fldtp': '2'});
		},
		save: function(){
			var TId = this._TId,
				pRows = this.getPriceRows();;
			this.tables.get('productlist').getRows().foreach(function(row){
				var di = row.cell, id = di['id'];
				
				pRows.foreach(function(crow){
					var nm = crow.cell['nm'];
					var val = Dom.get(TId['rcol']['pc']+nm+'-'+id).value * 1;
					if (val != di[nm]*1){
						var upd = {};
						upd[nm] = val;
						row.update(upd);
					}
				});
				
				var vcnt = Dom.get(TId['prow']['cnt']+'-'+id).value * 1;
				if (vcnt != di['cnt']*1){
					row.update({'cnt': vcnt});
				}
				var vord = Dom.get(TId['prow']['ord']+'-'+id).value * 1;
				if (vord != di['ord']*1){
					row.update({'ord': vord});
				}
			});
			this.tables.get('productlist').applyChanges();
			this.tables.request();
		},
		
		_thread: null,
		_startThread: function(){
    		if (!L.isNull(this._thread)){ return;}
			var __self = this;
			this._thread = setInterval(function(){
				__self._run();
			}, 10*1000);
    	},
    	_stopThread: function(){
            clearInterval(this._thread);
    	},
    	_run: function(){
    		this.save();
    	}
	};
	NS.PriceWidget = PriceWidget;

	var PricePanel = function(){
		PricePanel.superclass.constructor.call(this, {
			fixedcenter: true, width: '700px', height: '450px',
			controlbox: 1,
			overflow: false
		});
	};
	YAHOO.extend(PricePanel, Brick.widget.Panel, {
		initTemplate: function(){
			buildTemplate(this, 'panel');
			return this._TM.replace('panel');
		},
		onLoad: function(){
			this.widget = new PriceWidget(this._TM.getEl('panel.widget'));
			DATA.request();
		},
		onClick: function(el){
			if (this.widget.onClick(el)){ return true; }
			return false;
		},
		destroy: function(){
			this.widget.destroy();
			PricePanel.superclass.destroy.call(this);
		},
		onShow: function(){
			this.onResize();
		},
		onResize: function(){
			this.widget.onResize(Dom.getRegion(this.body));
		}
	});
	NS.PricePanel = PricePanel;
	
	API.showPricePanel = function(){
		NS.roles.load(function(){
			new PricePanel();
		});
	};
	
};