<?php
/**
 * @version $Id: module.php 575 2011-11-29 17:44:09Z roosit $
 * @package Abricos
 * @subpackage EPrice
 * @copyright Copyright (C) 2008 Abricos. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * @author Alexander Kuzmin (roosit@abricos.org)
 */

/**
 * Модуль "Прайс-лист интернет магазина" 
 */
class EPriceModule extends Ab_Module {
	
	private $_manager;
	
	function __construct(){
		$this->version = "0.1.1";
		$this->name = "eprice";
		$this->takelink = "eprice";
		
		$this->permission = new EPricePermission($this);
	}
	
	/**
	 * Получить менеджер
	 *
	 * @return EPriceManager
	 */
	public function GetManager(){
		if (is_null($this->_manager)){
			require_once 'includes/manager.php';
			$this->_manager = new EPriceManager($this);
		}
		return $this->_manager;
	}
}

class EPriceAction {
	const VIEW			= 10;
	const WRITE			= 30;
	const ADMIN			= 50;
}

class EPricePermission extends CMSPermission {
	
	public function EPricePermission(EPriceModule $module){
		$defRoles = array(
			new CMSRole(EPriceAction::VIEW, 1, User::UG_GUEST),
			new CMSRole(EPriceAction::VIEW, 1, User::UG_REGISTERED),
			new CMSRole(EPriceAction::VIEW, 1, User::UG_ADMIN),

			new CMSRole(EPriceAction::WRITE, 1, User::UG_ADMIN),
			new CMSRole(EPriceAction::ADMIN, 1, User::UG_ADMIN)
		);
		parent::CMSPermission($module, $defRoles);
	}
	
	public function GetRoles(){
		return array(
			EPriceAction::VIEW => $this->CheckAction(EPriceAction::VIEW),
			EPriceAction::WRITE => $this->CheckAction(EPriceAction::WRITE), 
			EPriceAction::ADMIN => $this->CheckAction(EPriceAction::ADMIN) 
		);
	}
}

Abricos::ModuleRegister(new EPriceModule());

?>