<?php
/**
 * @version $Id: dbquery.php 1413 2012-02-02 09:09:11Z roosit $
 * @package Abricos
 * @subpackage Feedback2
 * @copyright Copyright (C) 2008 Abricos. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * @author Gabidullin Mansur (mansur.gabidullin@gmail.com)
 */

/**
 * Статичные функции запросов к базе данных
 *
 * @package Abricos
 * @subpackage Feedback2
 */
class Feedback2Query {
	
	public static function ChitByContentId(Ab_Database $db, $contentid, $retarray = false){
		$sql = "
			SELECT
				p.itemid as id,
				p.userid as uid,
				u.username as unm,
				u.firstname as fnm,
				u.lastname as lnm,
				p.title as tl,
				c.body as bd,
				p.contentid as ctid,
				p.dateline as dl
			FROM ".$db->prefix."fb2_item p
			INNER JOIN ".$db->prefix."content c ON p.contentid=c.contentid
			LEFT JOIN ".$db->prefix."user u ON p.userid=u.userid
			WHERE p.contentid=".bkint($contentid)."
			LIMIT 1
		";
		return $retarray ? $db->query_first($sql) : $db->query_read($sql);
	}
	
	public static function FeedbackList(Ab_Database $db, $page, $limit, $sort, $mode){
		$from = (($page-1)*$limit);
		if($mode != -1) $wh = 'WHERE a.sectionid = '.bkint($mode);
		else $wh = '';
		if($sort == 'ch') $sort = 'a.checked';
		else if($sort == 'dt') $sort = 'a.dateline';
		else if($sort == 'sc') $sort = 'a.sectionid';
		else if($sort == 'tl') $sort = 'a.title';
		else if($sort == 'bd') $sort = 'c.body';
		else if($sort == 'st') $sort = 'a.statusid';
		else if($sort == 'vt') $sort = 'a.votecount';
		else $sort = 'a.itemid';
		
		$sql = "
			SELECT
				a.itemid as id,
				a.contentid as cid,
				a.title as tl,
				c.body,
				a.reply as rp,
				a.useremail as eml,
				a.username as unm,
				a.modername as munm,
				a.sectionid as scid,
				a.statusid as stid,
				a.dateline as dl,
				a.checked as ch,
				a.votecount as vtc
			FROM ".$db->prefix."fb2_item a
			LEFT JOIN ".$db->prefix."content c ON a.contentid = c.contentid
			LEFT JOIN ".$db->prefix."fb2_vote d ON a.itemid = d.itemid
			".$wh."
			ORDER BY '".bkstr($sort)."' DESC
			LIMIT ".intval($from).", ".intval($limit)."			
		";
		return $db->query_read($sql);
	}
	
	public static function FeedbackCount(Ab_Database $db, $mode){
		if($mode != -1) $wh = 'WHERE d.sectionid = '.bkint($mode);
		$sql = "
			SELECT count(*) as cnt
			FROM ".$db->prefix."fb2_item d
			".$wh."
			LIMIT 1			
		";
		return $db->query_read($sql);
	}
	
	public static function FeedbackAppend(Ab_Database $db, $userid, $username, $useremail, $d){
		$utmanager = Abricos::TextParser();		
		$d->body = $utmanager->Parser($d->body);
		$d->tl = $utmanager->Parser($d->tl);
		
		$contentid = Ab_CoreQuery::CreateContent($db, $d->body, 'feedback2');
		if($d->eml=='') $email = $useremail;
		$sql = "
			INSERT INTO ".$db->prefix."fb2_item 
				(userid, username, dateline, title, useremail, reply, statusid, sectionid, contentid, checked) VALUES (
					".bkint($userid).",
					'".bkstr($username)."',
					".TIMENOW.",
					'".bkstr($d->tl)."',
					'".bkstr($email)."',
					'".bkstr($d->rp)."',
					".bkint($d->stid).",
					".bkint($d->scid).",
					".$contentid.",
					1
				)
		";
		$db->query_write($sql);
		return $db->insert_id();
	}
	
	public static function FeedbackUpdate(Ab_Database $db, $userid, $username, $d){
		$utmanager = Abricos::TextParser();
		$d->body = $utmanager->Parser($d->body);
		$d->tl = $utmanager->Parser($d->tl);
		if($d->ch == 1)
			$md = "
				moderid=".bkint($userid).",
				modername='".bkstr($username)."',
		";

		$sql = "
			UPDATE ".$db->prefix."fb2_item 
			SET
				".$md."
				title='".bkstr($d->tl)."',
				useremail='".bkstr($d->eml)."',
				reply='".bkstr($d->rp)."',
				statusid=".bkint($d->stid).",
				sectionid=".bkint($d->scid).",
				checked=".bkint($d->ch)."
			WHERE itemid=".bkint($d->id)."
		";
		$db->query_write($sql);
		
		$sql = "
			UPDATE ".$db->prefix."content
			SET 
				body='".bkstr($d->body)."'
			WHERE contentid = (
				SELECT contentid
				FROM ".$db->prefix."fb2_item
				WHERE itemid=".bkint($d->id)."
			)
		";
		return $db->query_write($sql);
	}
	
	public static function FeedbackRemove(Ab_Database $db, $ideaid){
		$sql = "
			DELETE 
			FROM ".$db->prefix."content 
			WHERE contentid = 
				(	SELECT contentid
					FROM ".$db->prefix."fb2_item
					WHERE itemid=".bkint($ideaid)."
				)
		";
		$db->query_write($sql);
		
		$sql = "
			DELETE 
			FROM ".$db->prefix."fb2_item 
			WHERE itemid=".bkint($ideaid)."
		";
		return $db->query_write($sql);
	}
	
	public static function TaskAppend(Ab_Database $db, Feedback2Task $t){
		$contentid = Ab_CoreQuery::CreateContent($db, $t->body, 'feedback2');
		
		$sql = "
			INSERT INTO ".$db->prefix."fb2_item 
				(userid, username, useremail,  title, contentid, dateline, sectionid, statusid, checked) VALUES
				(
					".bkint($t->userid).",
					'".bkstr($t->username)."',
					'".bkstr($t->useremail)."',
					'".bkstr($t->title)."',
					".$contentid.",
					".TIMENOW.",
					".bkint($t->sectionid).",
					".bkint($t->statusid).",
					0
				)
		";
		$db->query_write($sql);
		
		return $db->insert_id();
	}
	
	public static function TopTable(Ab_Database $db, $limit){
		
		$sql = "
			SELECT
				d.id,
				d.sectionid,
				d.title,
				d.body,
				d.stid,
				d.ch,
				d.vtc
			FROM
				(
					SELECT
						a.itemid as id,
						a.contentid,
						a.sectionid,
						a.title,
						c.body,
						a.statusid as stid,
						a.checked as ch,
						a.votecount as vtc
					FROM ".$db->prefix."fb2_item a			
					LEFT JOIN ".$db->prefix."content c ON a.contentid = c.contentid
					LIMIT 0,".bkint($limit)."
				) d
			WHERE d.ch = 1
			ORDER BY d.vtc DESC
		";
		return $db->query_read($sql);
	}
	
	public static function IQETTable(Ab_Database $db, $iqet){
		if($iqet=='idea'){$iqet = 0;}
		else if($iqet=='questions'){$iqet = 1;}
		else if($iqet=='errors'){$iqet = 2;}
		else if($iqet=='thanks'){$iqet = 3;}
		$sql = "
			SELECT
				a.itemid as id,
				a.contentid as cid,
				a.sectionid,
				a.title,
				c.body,
				a.statusid as stid,
				a.reply as rp,
				a.checked as ch,
				a.votecount as vtc,
				1 as r, 1 as w				
			FROM ".$db->prefix."fb2_item a			
			LEFT JOIN ".$db->prefix."content c ON a.contentid = c.contentid
			WHERE a.checked = 1 AND a.sectionid = '".bkstr($iqet)."'
			ORDER BY a.itemid DESC
		";
		return $db->query_read($sql);
	}
	
	public static function AllTable(Ab_Database $db){
		
		$sql = "
			SELECT
				a.itemid as id,
				a.contentid as cid,
				a.sectionid,
				a.title,
				c.body,
				a.statusid as stid,
				a.reply as rp,
				a.checked as ch,
				a.votecount as vtc,
				1 as r, 1 as w				
			FROM ".$db->prefix."fb2_item a			
			LEFT JOIN ".$db->prefix."content c ON a.contentid = c.contentid
			WHERE a.checked = 1
			ORDER BY a.itemid DESC
		";
		return $db->query_read($sql);
	}
	
	public static function VoteUp(Ab_Database $db, $userid, $d){		
		$sql = "
			SELECT
				COUNT(*) as cnt
			FROM ".$db->prefix."fb2_vote			
			WHERE itemid = ".bkint($d->id)." and userid = ".bkint($userid)."
		";		
		$vtc = mysql_fetch_array($db->query_read($sql));
		if($vtc['cnt'] == 0){
			$sql = "
				SELECT
					votecount as vtcnt
				FROM ".$db->prefix."fb2_item			
				WHERE itemid = ".bkint($d->id)."
			";
			$vtcnt = mysql_fetch_array($db->query_read($sql));
			$vtcnt['vtcnt']++;
			
			$sql = "
			UPDATE ".$db->prefix."fb2_item 
					SET 
						votecount = ".$vtcnt['vtcnt']."
					WHERE itemid = ".bkint($d->id)."
			";
			$db->query_write($sql);
			$sql = "
				INSERT INTO ".$db->prefix."fb2_vote (userid, itemid)
				VALUES
					(
						".bkint($userid).",
						".bkint($d->id)."
					)
			";
			return $db->query_write($sql);
		}
		else if($vtc['cnt'] == 1) return 3;
		else return -1;
	}
	
	public static function VoteDown(Ab_Database $db, $userid, $d){
		$sql = "
			SELECT
				COUNT(*) as cnt
			FROM ".$db->prefix."fb2_vote			
			WHERE itemid = ".bkint($d->id)." and userid = ".bkint($userid)."
		";		
		$vtc = mysql_fetch_array($db->query_read($sql));
		if($vtc['cnt'] == 0){
			$sql = "
				SELECT
					votecount as vtcnt
				FROM ".$db->prefix."fb2_item			
				WHERE itemid = ".bkint($d->id)."
			";
			$vtcnt = mysql_fetch_array($db->query_read($sql));
			$vtcnt['vtcnt']--;
			
			$sql = "
			UPDATE ".$db->prefix."fb2_item 
					SET 
						votecount = ".$vtcnt['vtcnt']."
					WHERE itemid = ".bkint($d->id)."
			";
			$db->query_write($sql);
			$sql = "
				INSERT INTO ".$db->prefix."fb2_vote (userid, itemid)
				VALUES
					(
						".bkint($userid).",
						".bkint($d->id)."
					)
			";
			return $db->query_write($sql);
		}
		else if($vtc['cnt'] == 1) return 3;
		else return -1;
	}
	
	public static function VoteCheck(Ab_Database $db, $userid, $d){
		$sql = "
			SELECT
				COUNT(*) as cnt
			FROM ".$db->prefix."fb2_vote			
			WHERE itemid = ".bkint($d->id)." and userid = ".bkint($userid)."
		";		
		$vtc = mysql_fetch_array($db->query_read($sql));
		if($vtc['cnt'] == 0) return 2;
		else if($vtc['cnt'] == 1) return 3;
		else return -1;
	}
	
	public static function GetTip(Ab_Database $db, $d, $userid, $retarray = false){
		$sql = "
			SELECT
				COUNT(*) as cnt
			FROM ".$db->prefix."fb2_vote			
			WHERE itemid = ".bkint($d->tipid)." and userid = ".bkint($userid)."
		";		
		$vtc = mysql_fetch_array($db->query_read($sql));
		if($vtc['cnt'] == 1)$nv = '1 as nv';
		else $nv = '0 as nv';

		$sql = "
			SELECT
				a.itemid as id,
				a.contentid as cid,
				a.sectionid,
				a.title,
				c.body,
				a.statusid as stid,
				a.reply as rp,
				a.checked as ch,
				a.votecount as vtc,
				1 as r, 1 as w,
				".$nv." 
			FROM ".$db->prefix."fb2_item a			
			LEFT JOIN ".$db->prefix."content c ON a.contentid = c.contentid
			WHERE a.checked = 1 AND a.itemid = ".bkint($d->tipid)."
			LIMIT 1
		";
		return $retarray ? $db->query_first($sql) : $db->query_read($sql);
	}
	
	public static function GetModerTip(Ab_Database $db, $d, $userid, $retarray = false){
		$sql = "
			SELECT
				a.itemid as id,
				a.contentid as cid,
				a.title as tl,
				c.body,
				a.reply as rp,
				a.useremail as eml,
				a.username as unm,
				a.modername as munm,
				a.sectionid as scid,
				a.statusid as stid,
				a.dateline as dl,
				a.checked as ch,
				a.votecount as vtc
			FROM ".$db->prefix."fb2_item a
			LEFT JOIN ".$db->prefix."content c ON a.contentid = c.contentid
			LEFT JOIN ".$db->prefix."fb2_vote d ON a.itemid = d.itemid
			WHERE a.itemid = ".bkint($d->tipid)."
			LIMIT 1			
		";
		return $retarray ? $db->query_first($sql) : $db->query_read($sql);
	}
	
	public static function GetModers(Ab_Database $db){
		$sql = "	
			SELECT 
				u.userid as id,
				u.username as unm,
				u.lastname as elnm,
				u.firstname as efnm,
				u.email as eml
			FROM ".$db->prefix."user u
			LEFT JOIN ".$db->prefix."usergroup ug ON ug.userid = u.userid
			LEFT JOIN ".$db->prefix."group g ON g.groupid = ug.groupid
			WHERE g.groupkey='".Feedback2Group::MODERATOR."'
		";
		return $db->query_read($sql);
	}
	
	public static function GetFeedbackTitle(Ab_Database $db, $fbid){
		$sql = "	
			SELECT 
				a.title as tl
			FROM ".$db->prefix."fb2_item a
			WHERE a.itemid=".bkint($fbid)."
			LIMIT 1
		";
		$row = $db->query_first($sql);
		return $row['tl'];
	}
}

?>