<?php
/**
 * Схема таблиц модуля
 *
 * @version $Id: shema.php 1413 2012-02-02 09:09:11Z roosit $
 * @package Abricos
 * @subpackage Feedback2
 * @copyright Copyright (C) 2008 Abricos All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * @author Gabidullin Mansur (mansur.gabidullin@gmail.com)
 */

$charset = "CHARACTER SET 'utf8' COLLATE 'utf8_general_ci'";
$updateManager = Ab_UpdateManager::$current; 
$db = Abricos::$db;
$pfx = $db->prefix;

if ($updateManager->isInstall()){
	
}

if ($updateManager->isUpdate('0.1.0.2')){
	
	Abricos::GetModule('feedback2')->permission->Install();
	
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."fb2_item (
		  `itemid` int(10) unsigned NOT NULL auto_increment COMMENT 'Идентификатор записи',
		  `userid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор пользователя',
		  `moderid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор модератора',
		  `username` varchar(250) NOT NULL DEFAULT '' COMMENT 'Имя пользователя',
		  `modername` varchar(250) NOT NULL DEFAULT '' COMMENT 'Имя модератора',
		  `useremail` varchar(250) NOT NULL DEFAULT '' COMMENT 'Email пользователя',
		  `dateline` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Дата создания',
		  `sectionid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Раздел записи',
		  `statusid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор статуса',
		  `title` varchar(250) NOT NULL DEFAULT '' COMMENT 'Заголовок',
		  `contentid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор глобального контента',
		  `reply` varchar(250) NOT NULL DEFAULT '' COMMENT 'Ответ администратора',
		  `checked` int(1) unsigned NOT NULL DEFAULT 0 COMMENT 'Флаг проверки модератером',
		  `votecount` int(10) NOT NULL DEFAULT 0 COMMENT 'Количество голосов',
		  PRIMARY KEY  (`itemid`)
		)".$charset
	);
	
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."fb2_vote (
		  `voteid` int(10) unsigned NOT NULL auto_increment COMMENT 'Идентификатор записи',
		  `itemid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор отзыва',
		  `userid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор пользователя',		  
		  PRIMARY KEY  (`voteid`)
		)".$charset
	);
	
	// права пользователей на модерирование отзывов
	$db->query_write("
		CREATE TABLE IF NOT EXISTS ".$pfx."fb2_issend (		  
		  `userid` int(10) unsigned NOT NULL DEFAULT 0 COMMENT 'Идентификатор пользователя',
		  `issend` tinyint(1) unsigned NOT NULL DEFAULT 1 COMMENT 'Флаг на отправку уведомления',
		  PRIMARY KEY  (`userid`)
		)".$charset
	);	
	
}

?>