/*
* @version $Id: manager.js 977 2011-04-08 16:45:47Z Mansur $
* @copyright Copyright (C) 2008 Abricos. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	yahoo: ['dom', 'tabview', 'dragdrop'],
	mod:[
        {name: 'user', files: ['permission.js']},
		{name: 'sys', files: ['data.js', 'form.js', 'widgets.js', 'container.js']},
        {name: 'feedback2', files: ['roles.js']}
	]
};
Component.entryPoint = function(){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
	
	var NS = this.namespace, 
		TMG = this.template; 
	
	var API = NS.API,
		R = NS.roles;

	// загрузка роли пользователя
	var loadRoles = function(callback){
		R.load(function(){
			callback();
		});
	};

	var DPOINT = '.';

	if (!NS.data){
		NS.data = new Brick.util.data.byid.DataSet('feedback2');
	}
	
	var DATA = NS.data;
	
	var CACHE = {
			'moder': {}
		};
	
	var tabNum = 0;
	var buildTemplate = function(w, templates){
		var TM = TMG.build(templates), T = TM.data, TId = TM.idManager;
		w._TM = TM; w._T = T; w._TId = TId;
	};
	
	var buildUserName = function(user){
		var emp = function(s){
			s = s || '';
			return s.length < 1;
		};
		return (emp(user['fnm']) && emp(user['lnm'])) ? user['unm'] : user['fnm'] + ' ' + user['lnm']; 
	};
	
	API.showManagerWidget = function(container){
		loadRoles(function(){
			new NS.ManagerWidget(container);			
		});
	};
	
	var ManagerWidget = function(container){
		this.init(container);
		DATA.isFill({'all': DATA.get('all', true)}) ? this.refresh(false) : DATA.request();
	};
	ManagerWidget.prototype = {
		pages: null,
		init: function(container){
			buildTemplate(this, 'manager');
			var TM = this._TM, T = this._TM.data, TId = this._TM.idManager;
			
			container.innerHTML = T['manager'];
			
			var tabView = new YAHOO.widget.TabView(TM.getElId('manager.id'));
			
			var pages = {};
			pages['all'] = new NS.AllFeedbackWidget(TM.getEl('manager.all'),'all', this.refresh);
			pages['ideas'] = new NS.AllFeedbackWidget(TM.getEl('manager.ideas'),'ideas', this.refresh);
			pages['questions'] = new NS.AllFeedbackWidget(TM.getEl('manager.questions'),'questions', this.refresh);
			pages['errors'] = new NS.AllFeedbackWidget(TM.getEl('manager.errors'),'errors', this.refresh);
			pages['thanks'] = new NS.AllFeedbackWidget(TM.getEl('manager.thanks'),'thanks', this.refresh);
			this.pages = pages;
	
			var __self = this;
			E.on(container, 'click', function(e){
				if (__self.onClick(E.getTarget(e))){ E.stopEvent(e); }
			});
		},
		refresh: function(mode){
			var tables = [];
			if(mode){
				if (mode != 'all') {
					tables['all']= DATA.get('all');
					tables['all-count']= DATA.get('all-count');
				}
				if (mode != 'ideas') {
					tables['ideas']= DATA.get('ideas');
					tables['ideas-count']= DATA.get('ideas-count');
				}
				if (mode != 'questions') {
					tables['questions']= DATA.get('questions');
					tables['questions-count']= DATA.get('questions-count');
				}
				if (mode != 'errors') {
					tables['errors']= DATA.get('errors');
					tables['errors-count']= DATA.get('errors-count');
				}
				if (mode != 'thanks') {
					tables['thanks']= DATA.get('thanks');
					tables['thanks-count']= DATA.get('thanks-count');
				}
			}
			else tables = {
					'all': DATA.get('all'),
					'ideas': DATA.get('ideas'),
					'questions': DATA.get('questions'),
					'errors': DATA.get('errors'),
					'thanks': DATA.get('thanks'),
					'all-count': DATA.get('all-count'),
					'ideas-count': DATA.get('ideas-count'),
					'questions-coun': DATA.get('questions-count'),
					'errors-count': DATA.get('errors-count'),
					'thanks-count': DATA.get('thanks-count')
			};
			for(key in tables) tables[key].clear();
			DATA.request();
		},
		onClick: function(el){
			for (var n in this.pages){
				if (this.pages[n].onClick(el)){ return true; }
			}			
			var prefix = el.id.replace(/([0-9]+$)/, '');
			var numid = el.id.replace(prefix, "");
			tabNum = numid;
			return false;
		}
	};
	NS.ManagerWidget = ManagerWidget;

	var AllFeedbackWidget = function(container, mode, refresh){		
		container = L.isString(container) ? Dom.get(container) : container;
		this.mode = mode;
		this.refresh = refresh;
		buildTemplate(this,'all,feedbacktable,idearow,idearowwait');
		var TM = this._TM;
		
		AllFeedbackWidget.superclass.constructor.call(this, container, {
			filter: {'sort': 'id'},
			tm: TM,
			DATA: DATA,
			rowlimit: 10,
			tables: {'list': mode, 'count': mode+'-count'},
			paginators: ['all.pagtop', 'all.pagbot']
		});		
	};
	
	YAHOO.extend(AllFeedbackWidget, Brick.widget.TablePage, {		
		initTemplate: function(){
			DATA.onComplete.subscribe(this.dsEvent, this, true);
			return this._T['all'];
		},
		onLoad: function(){
			var TM = this._TM;
			if (!R.isAdmin){
				TM.getEl('all.bappend').style.display = 'none';
			}
		},
		renderTableAwait: function(){
			this._TM.getEl("all.table").innerHTML = this._TM.replace('feedbacktable', {
				'rows': this._T['idearowwait']
			});
		},
		renderRow: function(di){
			var stnm = Brick.util.Language.getc('feedback2.status.'+di['stid']);
			var scid = Brick.util.Language.getc('feedback2.section.'+di['scid']);		 
			
			var vtc = di['vtc'];
			return this._TM.replace('idearow', {
				'id': di['id'],
				'dl': Brick.dateExt.convert(di['dl']),
				'scnm': scid,
				'tl': di['tl'].length<25 ? di['tl'] : di['tl'].substr(0,25)+'....',			
	//			'body': di['body'].length<25 ? di['body'] : di['body'].substr(0,25)+'.....',
				'stnm': stnm,
				'vt': vtc,
				'dlt': R.isAdmin ? '' : 'none',
				'rw': R.isModerator ? 'none' : '',
				'nm': R.isModerator ? '' : 'none',
				'ch': di['ch'] == 1 ? 'checked' : ''
			});
		},
		renderTable: function(rows){
			this._TM.getEl("all.table").innerHTML = this._TM.replace('feedbacktable', {'rows': rows}); 
		},
		setFilterSort: function(filt){
			var sort = filt;
//			var table = DATA.get(this.mode).getRows({'sort': 'id'});
			this.setFilter({'sort': sort});
			DATA.request();
		},		
		onClick: function(el){
			
			var TM = this._TM, T = this._T, TId = this._TId;
			
			if (el.id == TM.getElId("all.refresh")){
				this.refresh(false);
				return true;
			}else if (el.id == TM.getElId("all.bappend")){
				this.editFeedback(0);
				return true;
			}else if (el.id == TM.getElId("feedbacktable.id")){
				this.setFilterSort('id');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.ch")){
				this.setFilterSort('ch');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.dt")){
				this.setFilterSort('dt');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.sc")){
				this.setFilterSort('sc');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.tl")){
				this.setFilterSort('tl');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.bd")){
				this.setFilterSort('bd');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.st")){
				this.setFilterSort('st');
				return true;
			}else if (el.id == TM.getElId("feedbacktable.vt")){			
				this.setFilterSort('vt');
				return true;
			}
			
			var prefix = el.id.replace(/([0-9]+$)/, '');
			var numid = el.id.replace(prefix, "");
			
			switch(prefix){
				case (TId['idearow']['view']+'-'): 
				case (TId['idearow']['edit']+'-'):
					this.editFeedback(numid); return true;
				case (TId['idearow']['remove']+'-'):
					this.remove(numid); return true;
			}
			return false;
		},
		editFeedback: function(ideaid){
			var table = DATA.get(this.mode);
			var rows = this.getRows();
			
			__self = this;
			var row = ideaid == 0 ? table.newRow() : rows.getById(ideaid);
			new FeedbackEditorPanel(row, function(){
				if (ideaid == 0){
					rows.add(row);
				}
				table.applyChanges();
				__self.refresh(__self.mode);
			});
		},
		remove: function(ideaid){
			if(!confirm('Удалить?')) return false; 
			var table = DATA.get(this.mode);
			var rows = this.getRows();
			
			var row = rows.getById(ideaid);
			row.remove();
			table.applyChanges();
			this.refresh(this.mode);
		}
	});
	NS.AllFeedbackWidget = AllFeedbackWidget;
	
	var FeedbackEditorPanel404 = function(){
		FeedbackEditorPanel404.superclass.constructor.call(this, {fixedcenter: true, width: '500px'});
	};
	YAHOO.extend(FeedbackEditorPanel404, Brick.widget.Panel, {
		initTemplate: function(){
			buildTemplate(this, 'ideaeditorpanel404');
			return this._TM.replace('ideaeditorpanel404');
		}
	});
	NS.FeedbackEditorPanel404 = FeedbackEditorPanel404;
	
	API.showFeedbackEditorPanel = function(id){
		R.load(function(){
			if(R.isModerator || R.isAdmin){
				var __self = this;
				Brick.ajax('feedback2', {
					'data': {
						'do': 'getmodertip',
						'tipid': id
					},
					'event': function(request){
						if (!request.data){
							new FeedbackEditorPanel404();
						}else{
							var row = {};
							row.cell = request.data;
							row.isNew = function(){return false;};
							new FeedbackEditorPanel(row, null);
							if(row.cell.ch==1) alert('Отзыв был проверен пользователем '+row.cell.munm+'');
						}
					}
				});
			}else alert('У Вас не права модераторства. Обратитесь к администратору.');
		});
	};
	
	var FeedbackEditorPanel = function(row, callback){
		this.row = row;
		this.callback = callback;
		this.isNew = row.isNew();
		
		FeedbackEditorPanel.superclass.constructor.call(this, {
			modal: true, fixedcenter: true, width: '600px', resize: false
		});
	};
	YAHOO.extend(FeedbackEditorPanel, Brick.widget.Panel, {
		el: function(template, name){ return Dom.get(this._TId[template][name]); },
		elv: function(template, name){ return Brick.util.Form.getValue(this.el(template, name)); },
		setelv: function(template, name, value){ Brick.util.Form.setValue(this.el(template, name), value); },
		initTemplate: function(){	
			buildTemplate(this, 'ideaeditor,ideastwidget,scwidget');
			return this._TM.replace('ideaeditor', {
				'ro':  this.row.cell['id']>0 ? 'readonly' : ''
			});			
		},
		onLoad: function(){
			var di = this.row.cell;
			this.setelv('ideaeditor', 'tl', di['tl']);
			this.setelv('ideaeditor', 'body', di['body']);
			
			!this.isNew	? this.setelv('ideaeditor', 'user', di['unm']) & this.setelv('ideaeditor', 'date', Brick.dateExt.convert(di['dl']))
				: this.el('ideaeditor', 'userdate').style.display='none';
			
			this.setelv('ideaeditor', 'eml', di['eml']);
			this._TM.getEl('ideaeditor.status').innerHTML = this._T['ideastwidget'];
			this._TM.getEl('ideaeditor.section').innerHTML = this._T['scwidget'];
			this.setelv('ideastwidget', 'rp', di['rp']);
			
			var cursctl = '', cursttl = '';
			var lst = "", TM = this._TM, T = this._T;
			var scid = di['scid'] || tabNum*1;
			var stid = di['stid'] || 0;
			var scnm = Brick.util.Language.getc('feedback2.section.'+scid);
			var stnm = Brick.util.Language.getc('feedback2.status.'+stid);
			cursctl = scnm;
			cursttl = stnm;
			this._TM.getEl('scwidget.cursc').innerHTML = cursctl;
			this._TM.getEl('ideastwidget.curst').innerHTML = cursttl;
			
			if (!R.isModerator){ TM.getEl('ideaeditor.checked').style.display = 'none';
			}else if (!R.isAdmin){ TM.getEl('ideaeditor.bsave').style.display = 'none';
			}else TM.getEl('ideaeditor.bsave').style.display = 'none';
			this.scid = scid;
			this.stid = stid;
		},
		onClick: function(el){
			var TId = this._TId;
			var tp = TId['ideaeditor'];
			switch(el.id){
				case tp['bcancel']: this.close(); return true;
				case tp['bsave']: this.save(); return true;
				case tp['checked']: this.save(); return true;
			}
			if (el.id == TId['scwidget']['bchangesc']){
				this.editsc();
				return true;
			}else if(el.id == TId['ideastwidget']['bchangest']){
				this.editst();
				return true;
			}
			return false;
		},
		editsc: function(){
			var __self = this;
			new FeedbackSectionEditorPanel(this.row, function(scid){
				__self.scid = scid;
				var scnm = Brick.util.Language.getc('feedback2.section.'+scid);
				__self._TM.getEl('scwidget.cursc').innerHTML = scnm;
			});
		},
		editst: function(){
			var __self = this;
			new FeedbackStatusEditorPanel(this.row, function(stid){
				__self.stid = stid;
				var stnm = Brick.util.Language.getc('feedback2.status.'+stid);
				__self._TM.getEl('ideastwidget.curst').innerHTML = stnm;
			});
		},
		save: function(){
			if(this.row.update){
				this.row.update({
					'tl': this.elv('ideaeditor', 'tl'),
					'body': this.elv('ideaeditor', 'body'),
					'eml': this.elv('ideaeditor', 'eml'),
					'rp': this.elv('ideastwidget', 'rp'),
					'ch': R.isModerator ? 1 : 0,
					'scid': this.scid,
					'stid': this.stid
				});
				this.callback();
			}else {
				Brick.ajax('feedback2', {
					'data': {
						'do': 'moderchecked',
						'd': {
							'id': this.row.cell.id,
							'tl': this.elv('ideaeditor', 'tl'),
							'body': this.elv('ideaeditor', 'body'),
							'eml': this.elv('ideaeditor', 'eml'),
							'rp': this.elv('ideastwidget', 'rp'),
							'ch': R.isModerator ? 1 : 0,
							'scid': this.scid,
							'stid': this.stid
						}
					},
					'event': function(request){
						if (!request.data || request.data*1 < 1){
							alert('Серверная ошибка! Приносим свои извинения за доставленные неудобства.');
						}
					}
				});
			}
			this.close();
		}
	});
	
	var FeedbackSectionEditorPanel = function(row,callback){
		this.row = row;
		this.callback = callback;
		
		FeedbackSectionEditorPanel.superclass.constructor.call(this, {
			modal: true,
			fixedcenter: true, width: '600px', resize: true
		});
	};
	YAHOO.extend(FeedbackSectionEditorPanel, Brick.widget.Panel, {
		el: function(name){ return Dom.get(this._TId['ideasecteditor'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		initTemplate: function(){
			buildTemplate(this, 'ideasecteditor');
			return this._T['ideasecteditor'];
		},
		onLoad: function(){
			var di = this.row.cell;
			this.sectSelWidget = new SectionSelectWidget(this._TM.getEl('ideasecteditor.sectsel'), di['scid']);
		},
		onClick: function(el){
			var tp = this._TId['ideasecteditor'];
			switch(el.id){
			case tp['bcancel']: this.close(); return true;
			case tp['bsave']: this.save(); return true;
			}
			return false;
		},
		save: function(){
			var scid = this.sectSelWidget.getSectionId();			
			this.callback(scid);
			this.close();
		}
	});
	
	var SectionSelectWidget = function(container, scid){
		this.init(container, scid);
	};
	SectionSelectWidget.prototype = {
		el: function(name){ return Dom.get(this._TId['sectseltable'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		init: function(container, scid){
			this.scid = scid;
			this.container = container;
			buildTemplate(this, 'sectseltable,sectselrow');
			var lst = '';
			var arr = Brick.util.Language.getc('feedback2.section');
			for(key in arr){
				lst += this._TM.replace('sectselrow', {
					'scnm': arr[key],
					'id': key
				});
			}
			this.container.innerHTML = this._TM.replace('sectseltable', {'rows': lst});
			this.setSectionId(this.scid);
		}, 
		setSectionId: function(scid){
			this.setelv('id', scid);
		},
		getSectionId: function(){
			return this.elv('id')*1;
		}
	};
	

	var FeedbackStatusEditorPanel = function(row,callback){
		this.row = row;
		this.callback = callback;
		
		FeedbackStatusEditorPanel.superclass.constructor.call(this, {
			modal: true,
			fixedcenter: true, width: '600px', resize: true
		});
	};
	YAHOO.extend(FeedbackStatusEditorPanel, Brick.widget.Panel, {
		el: function(name){ return Dom.get(this._TId['ideastateditor'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		initTemplate: function(){
			buildTemplate(this, 'ideastateditor');
			return this._T['ideastateditor'];
		},
		onLoad: function(){
			var di = this.row.cell;
			this.statSelWidget = new StatusSelectWidget(this._TM.getEl('ideastateditor.statsel'), di['stid']);
		},
		onClick: function(el){
			var tp = this._TId['ideastateditor'];
			switch(el.id){
			case tp['bcancel']: this.close(); return true;
			case tp['bsave']: this.save(); return true;
			}
			return false;
		},
		save: function(){			
			var stid = this.statSelWidget.getStatusId();
			if (stid < 1){
				alert(this.elv('msgerr'));
				return;
			}
			this.callback(stid);
			this.close();
		}
	});
	

	var StatusSelectWidget = function(container, statid){
		statid = statid || 0;
		this.init(container, statid);
	};
	StatusSelectWidget.prototype = {
		el: function(name){ return Dom.get(this._TId['statseltable'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		init: function(container, statid){
			this.statid = statid;
			this.container = container;
			buildTemplate(this, 'statseltable,statselrow');
			var lst = '';
			var arr = Brick.util.Language.getc('feedback2.status');
			for(key in arr)
				lst += this._TM.replace('statselrow', {
					'stnm': arr[key],
					'id': key
				});			
			this.container.innerHTML = this._TM.replace('statseltable', {'rows': lst});
			this.setStatusId(this.statid);
		}, 
		setStatusId: function(statid){
			this.setelv('id', statid);
		},
		getStatusId: function(){
			return this.elv('id')*1;
		}
	};	
};