/*
* @version $Id: ui.js 977 2011-04-08 16:45:47Z Mansur $
* @copyright Copyright (C) 2008 Abricos. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

var Component = new Brick.Component();
Component.requires = {
	yahoo: ['dom','tabview','dragdrop','resize'],
	mod:[
		{name: 'sys', files: ['wait.js', 'form.js', 'container.js','widgets.js']},
		{name: 'feedback2', files: ['roles.js']}
	]
};

Component.entryPoint = function(){
	
	var Dom = YAHOO.util.Dom,
		E = YAHOO.util.Event,
		L = YAHOO.lang;
		LNG = Brick.util.Language;
	
	var NS = this.namespace,
		TMG = this.template;
	
	var API = NS.API,
		R = NS.roles,
		F = Brick.Component.API.fire,
		FF = Brick.Component.API.fireFunction;
	
	var LW = Brick.widget.LayWait;

	if (!NS.data){
		NS.data = new Brick.util.data.byid.DataSet('feedback2');
	}
	var DATA = NS.data;
	
	Brick.util.CSS.update(Brick.util.CSS['feedback2']['ui']);
	delete Brick.util.CSS['feedback2']['ui'];
		
	var buildTemplate = function(w, templates){
		var TM = TMG.build(templates), T = TM.data, TId = TM.idManager;
		w._TM = TM; w._T = T; w._TId = TId;
	};	
	
	API.showButton = function(elId){		
		var container = Dom.get(elId);
		var lw = new LW(container);
		
		if (L.isNull(container)){ return; }
				
		E.on(container, 'click', function(e){
			new NS.FeedbackPanel(true);
			lw.hide();
		});
		container.style.display = "";		
	};
	
	var FeedbackPanel = function(modal){		
		FeedbackPanel.superclass.constructor.call(this, {
			width: "auto", height: "auto",
			fixedcenter: true,
			modal: modal
		});
		var container = Dom.get(this._TId['panel']['TableView']);
		this.ClientManagerWidget = new ClientManagerWidget(container,this);
		DATA.isFill(this.tables) ? this.refresh(false) : DATA.request();
	};	
	YAHOO.extend(FeedbackPanel, Brick.widget.Panel, {
		el: function(name){ return Dom.get(this._TId['panel'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		initTemplate: function(){
			var TM = TMG.build('panel'), T = TM.data, TId = TM.idManager;
			this._TM = TM; this._T = this._TM.data; this._TId = TId;
			return T['panel'];
		},
		onLoad: function(){			
		},
		onResize: function(){
			this.ClientManagerWidget.onResize(Dom.getRegion(this.body));
		},
		tables : {
			'ui-top': DATA.get('ui-top', true),
			'ui-all': DATA.get('ui-all', true),
			'ui-ideas': DATA.get('ui-ideas', true),
			'ui-questions': DATA.get('ui-questions', true),
			'ui-errors': DATA.get('ui-errors', true),
			'ui-thanks': DATA.get('ui-thanks', true)
		},
		refresh:function(mode){
			var tables = [];
			if(mode){
				if (mode != 'ui-top')tables['ui-top']= DATA.get('ui-top');
				if (mode != 'ui-all')tables['ui-all']= DATA.get('ui-all');
				if (mode != 'ui-ideas')tables['ui-ideas']= DATA.get('ui-ideas');
				if (mode != 'ui-questions')tables['ui-questions']= DATA.get('ui-questions');
				if (mode != 'ui-errors')tables['ui-errors']= DATA.get('ui-errors');
				if (mode != 'ui-thanks')tables['ui-thanks']= DATA.get('ui-thanks');
			}
			else tables = this.tables;
			for(key in tables) tables[key].clear();
			DATA.request();
		},
		onClick: function(el){			
			var container = Dom.get(el);
			var lw = new LW(container);
			var TId = this._TId;			
			switch(el.id) {
				case TId['panel']['baddidea']:{
					new NS.AddPanel(this.elv('idea'));
					lw.hide();
//					if(Brick.env.user.isRegister()){
//						new NS.AddPanel(this.elv('idea'));
//						lw.hide();						
//					}else{
//						alert(Brick.util.Language.getc('feedback2.ui.noregistered'));
//						lw.hide();
//					}
					return true;
				}					
				case TId['panel']['updt_btn']:{
					this.refresh(false);
					lw.hide();
					return true;
				}
				case TId['panel']['idea']:{
					Dom.get(TId['panel']['idea']).value='';
					lw.hide();
					return true;
				}
				case TId['panel']['search-block']:{
					Dom.get(TId['panel']['idea']).value='';
					Dom.get(TId['panel']['idea']).select();
					Dom.get(TId['panel']['idea']).focus();
					lw.hide();
					return true;
				}
			}
			lw.hide();
			return false;						
		}
	});
	NS.FeedbackPanel = FeedbackPanel;
	
	var ViewPanel404 = function(){
		ViewPanel404.superclass.constructor.call(this, {fixedcenter: true, width: '500px'});
	};
	YAHOO.extend(ViewPanel404, Brick.widget.Panel, {
		initTemplate: function(){
			buildTemplate(this, 'viewpanel404');
			return this._TM.replace('viewpanel404');
		}
	});
	NS.ViewPanel404 = ViewPanel404;
	
	API.showViewPanel = function(id){
		R.load(function(){
			var __self = this;
			Brick.ajax('feedback2', {
				'data': {
					'do': 'gettip',
					'tipid': id
				},
				'event': function(request){
					if (!request.data){
						new ViewPanel404();
					}else{
						new ViewPanel(request.data, null);
						DATA.request();
					}
				}
			});
		});
	};
	
	var ViewPanel = function(tip, callback){
		this.di = tip;
		this.callback = callback;
		ViewPanel.superclass.constructor.call(this, {
			width: "610px", height: "600px",
			fixedcenter: true, modal: true
		});
	};
	YAHOO.extend(ViewPanel, Brick.widget.Panel, {		
		el: function(name){ return Dom.get(this._TId['viewpanel'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		initTemplate: function(){
			buildTemplate(this,'viewpanel');
			var lst = '';
			var st = '';
			var arr = Brick.util.Language.getc('feedback2.status');
			for(key in arr){
				if(this.di['stid']==key)	st = arr[key];
			}
			lst += this._TM.replace('viewpanel', {
				'sc': Brick.util.Language.getc('feedback2.section.'+this.di['sectionid']),
				'tl': this.di['title'],
				'bd': this.di['body'],
				'st': st,
				'vt': this.di['vtc'],
				'rp': this.di['rp'] || Brick.util.Language.getc('feedback2.ui.noreply')
			});
			return lst;
		},
		onLoad: function(){
			var __self = this;
			var scrollToComment = function(commentid, builder){
				return true;
			};
			Brick.ff('comment', 'comment', function(){
				Brick.mod.comment.API.buildCommentTree({
					'container': __self._TM.getEl('viewpanel.comment'),
					'dbContentId': __self.di['cid'],
					'config': {
						'onLoadComments': null,
						'readOnly': __self.di['w']*1 == 0,
						'manBlock': new Brick.mod.comment.ManagerBlockWidget(
								__self._TM.getEl('viewpanel.manblock'),
							'position: absolute; right: 16px; top: 43%;',
							scrollToComment
						)
					},
					'instanceCallback': function(b){ }
				});
			});
			if(this.di['nv']*1==1){
				Dom.get(__self._TId['viewpanel']['up']).style.visibility = 'hidden';
				Dom.get(__self._TId['viewpanel']['dw']).style.visibility = 'hidden';
			}
		},
		onClose: function(){
			if(!L.isNull(this.callback))this.callback();
		},
		onClick: function(el){
			var TId = this._TId;
			switch(el.id) {
				case TId['viewpanel']['up']:{
					if(Brick.env.user.isRegister()){
						this.up();
					}else{
						alert(Brick.util.Language.getc('feedback2.ui.noregistered'));
					}
					return true;
				}
				case TId['viewpanel']['dw']:{
					if(Brick.env.user.isRegister()){
						this.down();
					}else{
						alert(Brick.util.Language.getc('feedback2.ui.noregistered'));
					}
					return true;
				}
			}
			return false;						
		},
		up: function(){
			var __self = this;
			Brick.ajax('feedback2', {
				'data': {
					'do': 'up',
					'id': this.di['id']
				},
				'event': function(request){
					if (request.data*1 < 1){
						alert(Brick.util.Language.getc('feedback2.ui.error'));
					}else{
						if(request.data*1 == 3){
							alert(Brick.util.Language.getc('feedback2.ui.nolonger'));
						}else{
							__self.el('vts').innerHTML = __self.di['vtc']*1+1;
							__self.el('ratingCount').innerHTML = __self.di['vtc']*1+1;
							Dom.get(__self._TId['viewpanel']['up']).style.visibility = 'hidden';
							Dom.get(__self._TId['viewpanel']['dw']).style.visibility = 'hidden';
						}
					}
				}
			});
		},
		down: function(){
			var __self = this;
			Brick.ajax('feedback2', {
				'data': {
					'do': 'down',
					'id': this.di['id']
				},
				'event': function(request){					
					if (request.data*1 < 1){
						alert(Brick.util.Language.getc('feedback2.ui.error'));
					}else{
						if(request.data*1 == 3){
							alert(Brick.util.Language.getc('feedback2.ui.nolonger'));
						}else{							
							__self.el('vts').innerHTML = __self.di['vtc']*1-1;
							__self.el('ratingCount').innerHTML = __self.di['vtc']*1-1;
							Dom.get(__self._TId['viewpanel']['up']).style.visibility = 'hidden';
							Dom.get(__self._TId['viewpanel']['dw']).style.visibility = 'hidden';
						}
					}
				}
			});
		}
	});
	
	var AddPanel = function(title){
		this.title = title || '';
		AddPanel.superclass.constructor.call(this, {
			width: "auto", height: "auto",
			fixedcenter: true, modal: true
		});
	};
	YAHOO.extend(AddPanel, Brick.widget.Panel, {		
		el: function(name){ return Dom.get(this._TId['addPanel'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		initTemplate: function(){
			var TM = TMG.build('addPanel'), T = TM.data, TId = TM.idManager;
			this._TM = TM; this._T = this._TM.data; this._TId = TId;
			return T['addPanel'];
		},
		onLoad: function(){
			if(Brick.env.user.isRegister()){
				this.el('email').style.display = 'none';
				this.el('emailtl').style.display = 'none';
			}
			this.setelv('title', this.title);
			var container = this.el('selsc');
			this.sectSelWidget = new SectionSelectWidget(container, 0);
		},
		onClick: function(el){
			var TId = this._TId;
			switch(el.id) {
				case TId['addPanel']['bsave']:{
					this.saveFeedback();				
					return true;
				}
				case TId['addPanel']['title']:{
					Dom.get(TId['addPanel']['title']).value='';
					return true;
				}
			}
			return false;						
		},
		saveFeedback: function(){			
			var __self = this;			
			var lw = new LW(document.body, true);
			
			var scid = this.sectSelWidget.getSectionId();	
			var title = this.elv('title'),
				body = this.elv('body'),
				email = this.elv('email');
			if(title!=''&&body!=''){
				Brick.ajax('feedback2', {
					'data': {
						'do': 'add',
						'sectionid': scid,
						'title': title,
						'body': body,
						'email': Brick.env.user.isRegister() ? 0 : email
					},
					'event': function(request){
						lw.hide();
						__self.close();
						if (request.data*1 < 1){
							alert(Brick.util.Language.getc('feedback2.ui.error'));
						}else{
							var tables = {
								'ui-top': DATA.get('ui-top', true),
								'ui-all': DATA.get('ui-all', true),
								'ui-ideas': DATA.get('ui-ideas', true),
								'ui-questions': DATA.get('ui-questions', true),
								'ui-errors': DATA.get('ui-errors', true),
								'ui-thanks': DATA.get('ui-thanks', true)
							};
							for(key in tables) tables[key].clear();
							DATA.request();
							alert(Brick.util.Language.getc('feedback2.ui.add'));
						}
					}
				});
			}else {
				alert(Brick.util.Language.getc('feedback2.ui.nothing'));
				lw.hide();
			}
		}		
	});
	NS.AddPanel = AddPanel;	
	
	var SectionSelectWidget = function(container, scid){
		this.init(container, scid);
	};
	SectionSelectWidget.prototype = {
		el: function(name){ return Dom.get(this._TId['sectseltable'][name]); },
		elv: function(name){ return Brick.util.Form.getValue(this.el(name)); },
		setelv: function(name, value){ Brick.util.Form.setValue(this.el(name), value); },
		init: function(container, scid){
			this.scid = scid;
			this.container = container;
			buildTemplate(this, 'sectseltable,sectselrow');
			var lst = '';
			var arr = Brick.util.Language.getc('feedback2.section');
			for(key in arr){
				lst += this._TM.replace('sectselrow', {
					'scnm': arr[key],
					'id': key
				});
			}
			this.container.innerHTML = this._TM.replace('sectseltable', {'rows': lst});
			this.setSectionId(this.scid);
		}, 
		setSectionId: function(scid){
			this.setelv('id', scid);
		},
		getSectionId: function(){
			return this.elv('id')*1;
		}
	};

	var ClientManagerWidget = function(container,owner){
		this.owner = owner;
		this.init(container);
	};
	ClientManagerWidget.prototype = {		
		pages: null,
		init: function(container){
			buildTemplate(this, 'manager');
			var TM = this._TM, T = this._T, TId = this._TId;			
			container.innerHTML = T['manager'];
			var tabView = new YAHOO.widget.TabView(TM.getElId('manager.id'));			
			var pages = {};
			pages['top'] = new NS.AllWidget(TM.getEl('manager.top'),'ui-top',this.owner);
			pages['all'] = new NS.AllWidget(TM.getEl('manager.all'),'ui-all',this.owner);
			pages['ideas'] = new NS.AllWidget(TM.getEl('manager.ideas'),'ui-ideas',this.owner);
			pages['questions'] = new NS.AllWidget(TM.getEl('manager.questions'),'ui-questions',this.owner);
			pages['errors'] = new NS.AllWidget(TM.getEl('manager.errors'),'ui-errors',this.owner);
			pages['thanks'] = new NS.AllWidget(TM.getEl('manager.thanks'),'ui-thanks',this.owner);
			this.pages = pages;
	
			var __self = this;
			E.on(container, 'click', function(e){
				if (__self.onClick(E.getTarget(e))){ E.stopEvent(e); }
			});
		},
		onClick: function(el){
			for (var n in this.pages){
				if (this.pages[n].onClick(el)){ return true; }
			}
			return false;
		},
		onResize: function(rel){
			this.pages['top'].onResize(rel);
			this.pages['all'].onResize(rel);
			this.pages['ideas'].onResize(rel);
			this.pages['questions'].onResize(rel);
			this.pages['errors'].onResize(rel);
			this.pages['thanks'].onResize(rel);
		}
	};
	NS.ClientManagerWidget = ClientManagerWidget;
	
	
	var AllWidget = function(el, mode, owner){
		this.mode = mode;
		this.owner = owner;
		this.table = DATA.get(this.mode, true);
		this.init(el);
	};	
	AllWidget.prototype = {
		init: function(el){
			buildTemplate(this,'all,alltable,allrowwait,allrow,1,2,3,4,5,6,7,8,9,10,11,12');	
			el.innerHTML = this._T['all'];
			
			DATA.onStart.subscribe(this.dsEvent, this, true);
			DATA.onComplete.subscribe(this.dsEvent, this, true);
			DATA.isFill({'ui-top' : DATA.get(this.mode, true)}) ? this.render() : this.renderWait();				
			
	    },
	    onResize: function(rel){
			var el = this._TM.getEl('all.allcntab');
			el.style.height = (rel.height - 200)+'px';
	    },
	    dsEvent: function(type, args){
			if (args[0].checkWithParam(this.mode, {})){
				type == 'onComplete' ? this.render() : this.renderWait(); 
			}
		},
	    renderWait: function(){
			var TM = this._TM, T = this._T;
			TM.getEl('all.allcntab').innerHTML = TM.replace(
					'alltable',
					{
						'allrows': T['allrowwait']
					}
			);
		},
		render: function(){
			var lst = "", TM = this._TM, T = this._T;
			var vt = 0;
			DATA.get(this.mode).getRows().foreach(function(row){
				var di = row.cell;
				var st = "";
				var arr = Brick.util.Language.getc('feedback2.status');
				var vtlba = Brick.util.Language.getc('feedback2.votelabels.2');
				var str='';
				for(key in arr){
					if(di['stid']==key)	st = TM.replace(key+'', { 'stname': arr[key]});
				}
				vtc = di['vtc'];
				if(vtc){					
					var number = vtc;
					var n = number%100;
					if( (Math.abs(n) >10) && (Math.abs(n) < 20) ) vtlba = Brick.util.Language.getc('feedback2.votelabels.2');
					else{
						n = number%10;
						if(Math.abs(n) == 1) vtlba = Brick.util.Language.getc('feedback2.votelabels.0');				
						else if(Math.abs(n)>1 && Math.abs(n)<5) vtlba = Brick.util.Language.getc('feedback2.votelabels.1');
					}						
				}
				lst += TM.replace('allrow', {
					'id': di['id'],
					'sc': Brick.util.Language.getc('feedback2.section.'+di['sectionid']),
					'tl': di['title'].length<30 ? di['title'] : di['title'].substr(0,30)+'...',
					'bd': di['body'].length<50 ? di['body'] : di['body'].substr(0,50)+'...',
					'st': st,
					'vt': vtc,
					'vtlba': vtlba
				});
			});
			this._TM.getEl('all.allcntab').innerHTML = TM.replace('alltable', {'allrows': lst});
		},
		onClick: function(el){
			var TId = this._TId;
			var prefix = el.id.replace(/([0-9]+$)/, '');
			var numid = el.id.replace(prefix, "");
			
			switch(prefix) {
				case (TId['allrow']['view']+'-'):{
					var __self = this;
					Brick.ajax('feedback2', {
						'data': {
							'do': 'gettip',
							'tipid': numid
						},
						'event': function(request){
							if (!request.data){
								alert(Brick.util.Language.getc('feedback2.ui.error'));
							}else{
								var tip = request.data;
								if(!tip){this.panel404();return false;}
								else{
									new ViewPanel(tip, function(){
										__self.owner.refresh();
									});
									DATA.request();
									return true;
								}
							}
						}
					});
				}
			}
			return false;
		}
	};    
	NS.AllWidget = AllWidget;
};